//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   sgdResult->Cells[0][0] = "x";
   sgdResult->Cells[1][0] = "f(x)";
   sdgCoefficients->Cells[1][0] = "Coefficients";

   m_nAdded = 0;
   m_sf = new TStringList();
   m_sv = new TStringList();
   btnGenerateClick(Sender);

   sgdResult->Cells[0][1] = "1";
   sgdResult->Cells[1][1] = "4";
   sgdResult->Cells[0][2] = "2";
   sgdResult->Cells[1][2] = "8";
   sgdResult->Cells[0][3] = "3";
   sgdResult->Cells[1][3] = "20";
   sgdResult->Cells[0][4] = "4";
   sgdResult->Cells[1][4] = "46";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
   delete m_sf;
   delete m_sv;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::btnGenerateClick(TObject *Sender)
{
   m_sf->Clear();
   m_sv->Clear();
   
   m_nDegree = StrToIntDef(txtDegree->Text, -1);

   if (m_nDegree>1)
   {
      sgdResult->RowCount = m_nDegree +2;
      sdgCoefficients->RowCount = m_nDegree +2;

      sgdAns1->ColCount = m_nDegree +2;
      sgdAns1->RowCount = sgdResult->ColCount;
      sgdAns1->Cells[0][0] = "Answer";
   }

   AnsiString fx1;
   AnsiString fx2;
   AnsiString cof;

   for (int i=0; i<=m_nDegree; i++)
   {
      cof = char(65+i);
      sdgCoefficients->Cells[0][i+1] = cof;
      sgdAns1->Cells[i+1][0] = cof;      

      m_sf->Add(cof);

      if (i>0) fx1 += " + ";
      fx1 += cof;
      if (i>0) fx1 += "x^"+IntToStr(i);
   }
   txtFx1->Text = fx1;

   for (int i=m_sf->Count-1; i>=0; i--)
   {
      if ((i+1)==m_sf->Count && i > 1)
      {
         fx2 += m_sf->Strings[i] +"x";
      }
      else
      {
         if (fx2!="") fx2 += " + ";
         if (i>0)
         {
            fx2 = "("+ fx2 + m_sf->Strings[i] +")x";
         }
         else
         {
            fx2 += m_sf->Strings[i];
         }
      }
   }
   txtFx2->Text = fx2;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnAddClick(TObject *Sender)
{
   if (m_nAdded < sgdResult->RowCount-1)
   {
      if(sgdResult->Cells[0][sgdResult->Row].Trim() == "" &&
         sgdResult->Cells[1][sgdResult->Row].Trim() == "")
      {
         sgdResult->Cells[0][sgdResult->Row] = txtX->Text;
         sgdResult->Cells[1][sgdResult->Row] = txtFx->Text;
         m_nAdded++;

         if (sgdResult->Row < sgdResult->RowCount-1)
            sgdResult->Row++;
         else
            sgdResult->Row = 1;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnDelClick(TObject *Sender)
{
   if(sgdResult->Cells[0][sgdResult->Row].Trim() != "" ||
      sgdResult->Cells[1][sgdResult->Row].Trim() != "")
   {
      sgdResult->Cells[0][sgdResult->Row] = "";
      sgdResult->Cells[1][sgdResult->Row] = "";
      m_nAdded--;
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnClearClick(TObject *Sender)
{
   m_nAdded =0;
   for (int i=1; i<sgdResult->RowCount; i++)
   {
      sgdResult->Cells[0][i] = "";
      sgdResult->Cells[1][i] = "";
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::sgdResultSelectCell(TObject *Sender, int ACol,
      int ARow, bool &CanSelect)
{
   txtX->Text = sgdResult->Cells[0][ARow];
   txtFx->Text = sgdResult->Cells[1][ARow];
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnGetCoefficientsClick(TObject *Sender)
{
   for (int i=1; i< sgdAns1->RowCount; i++)
      sgdAns1->Rows[i]->Clear();
   sgdAns1->RowCount = 2;
   
   int t = 1;
   for (int i=1; i<= sgdResult->RowCount-1; i++)
   {
       sgdAns1->Cells[0][t] = sgdResult->Cells[1][t];

       for (int j=0; j<sgdAns1->ColCount-1; j++)
       {
          float x = StrToFloat(sgdResult->Cells[0][t]);
          if (x==0 && j==0)
             sgdAns1->Cells[j+1][t] = 1;
          else
             sgdAns1->Cells[j+1][t] = FloatToStr(pow(x, j));
       }

       t++;
       sgdAns1->RowCount++;
   }
   sgdAns1->RowCount--;

   int InPt = 1;
   int row, col;
   for (row=1; row< sgdAns1->RowCount; row++)
   {
      float Div= StrToFloat(sgdAns1->Cells[InPt][row]);

      for (col=0; col< sgdAns1->ColCount; col++)
      {
         sgdAns1->Cells[col][row] =
         FloatToStr(
            StrToFloat(sgdAns1->Cells[col][row]) / Div
            );
      }

      for (int rn= row+1; rn < sgdAns1->RowCount; rn++)
      {
         float substitution = StrToFloat(sgdAns1->Cells[InPt][rn]);

         for (int cn=0; cn< sgdAns1->ColCount; cn++)
         {
            float Now = StrToFloat(sgdAns1->Cells[cn][rn]);
            float Last = StrToFloat(sgdAns1->Cells[cn][row]);
            float result = Now-Last*substitution;
            sgdAns1->Cells[cn][rn] = FloatToStr(result);
         }
      }
      InPt++;
   }

   int AnsCount = 0;
   int need = sgdAns1->ColCount;

   for (int i= sgdAns1->RowCount-1; i>=1; i--)
   {
      float Ans = StrToFloat(sgdAns1->Cells[0][i]);

      for (int j=sgdAns1->ColCount; j>need-AnsCount; j--)
      {
         float coff = StrToFloat(sdgCoefficients->Cells[1][j-1]);
         float Now = StrToFloat(sgdAns1->Cells[j-1][i]);
         Ans -= (Now*coff);
      }
      sdgCoefficients->Cells[1][i] = FloatToStr(Ans);
      AnsCount++;
   }


   AnsiString zResult;
   for (int i=0; i<sdgCoefficients->RowCount-1; i++)
   {
      if (i>0) zResult += " + ";

      zResult += sdgCoefficients->Cells[1][i+1];

      if (i>0)
         zResult += "x^"+IntToStr(i);
   }
   txtResult->Text = zResult;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnFxClick(TObject *Sender)
{
   double* coeffs = new double[m_nDegree+1];
   AnsiString val;
   bool bCan = true;
   for (int i=0; i<=m_nDegree; i++)
   {
       val = sdgCoefficients->Cells[1][i+1];
       if (val.Trim()=="")
          bCan = false;
       else
          coeffs[i] = StrToFloat(val);
   }

   if (bCan)
   {
      double x = StrToFloat(txtRX->Text);
      double y = poly(x, m_nDegree, coeffs);

      txtRfx->Text = FloatToStr(y);
   }
   
   delete [] coeffs;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnDrawClick(TObject *Sender)
{
   Chart1->RemoveAllSeries(); // MChart1WҦ Series

   Chart1->View3D=true; // n 3D 
   Chart1->Legend->Visible=false; // qϨһ
   // ]w Chart Title W
   Chart1->Title->Text->Clear();
   Chart1->Title->Text->Add("Poly");

   TLineSeries* Series1=new TLineSeries(Chart1) ;
   Series1->ParentChart=Chart1;

   Series1->Marks->Visible=true; // ]wnܻ
   Series1->Marks->Style=smsValue; // ܻe Label
   Series1->SeriesColor=clRed; // ]u1,]h۰ʵ

   // J
   double fx; // Value
   String L; //Label
   double step = StrToFloat(txtStep->Text);
   for (double i = StrToFloat(txtMin->Text); i <= StrToFloat(txtMax->Text); i+=step)
   {
      txtRX->Text = FloatToStr(i);
      btnFxClick(Sender);

      if (txtRfx->Text.Trim() != "")
      {
         fx = StrToFloat(txtRfx->Text);
         L=FloatToStr(i); // bW
         Series1->Add( fx , L , clTeeColor );
      }
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PolyChange(TObject *Sender)
{
   AnsiString sval;
   double val, min, max, step;
   bool bStart = true;
   for (int i=1; i<sgdResult->RowCount; i++)
   {
      sval = sgdResult->Cells[0][i].Trim();
      if (sval!="")
      {
         val = StrToFloat(sval);
         if (bStart)
         {
            min = val;
            max = val;
            bStart = false;
         }
         else
         {
            if (val>max) max = val;
            else if (val<min) min = val;
         }
      }
   }
   step = (max-min)/10;
   txtMin->Text = FloatToStr(min);
   txtMax->Text = FloatToStr(max);
   txtStep->Text = FloatToStr(step);
}
//---------------------------------------------------------------------------


